-
Data Grids / Data Management
-
Data Grid
- Overview
-
Data Binding
-
Filtering
- Sorting
-
Editing
-
Grouping
-
Selection
- Focused Row
- Paging
-
Scrolling
-
Columns
-
Master-Detail
-
Data Summaries
-
Drag & Drop
-
Export to PDF
-
Export to Excel
- Appearance
-
Customization
- State Persistence
-
Adaptability
-
Keyboard Navigation
- Right-To-Left Support
-
Tree List
- Overview
-
Data Binding
-
Filtering
- Sorting
-
Editing
-
Selection
- Focused Row
- Paging
-
Columns
- Drag & Drop
- State Persistence
- Adaptability
-
Keyboard Navigation
-
Card View
-
Pivot Grid
- Overview
-
Data Binding
-
Field Management
-
Data Summaries
- Drill Down
- Filtering
-
Scrolling
-
Export to Excel
- Chart Integration
- Customization
- State Persistence
-
Filter Builder
-
-
Data Visualization
-
Charts
- Overview
-
Data Binding
-
Common Concepts
-
Axis
-
Aggregation
-
Tooltips
-
Selection
-
Customization
-
Zooming
-
Export
-
-
Area Charts
-
Bar Charts
- Bullet Charts
-
Doughnut Charts
-
Financial Charts
-
Funnel and Pyramid Charts
-
Line Charts
- Pareto Chart
-
Pie Charts
-
Point Charts
-
Polar and Radar Charts
-
Range Charts
- Sankey Chart
-
Sparkline Charts
-
Tree Map
-
Gauges
- Overview
-
Runtime update
-
Bar Gauge
-
Circular Gauge
-
Linear Gauge
-
Diagram
- Overview
-
Data Binding
-
Featured Shapes
-
Custom Shapes
-
Document Capabilities
-
User Interaction
- UI Customization
- Adaptability
-
-
Scheduling / Planning
-
Scheduler
- Overview
-
Data Binding
-
Views
-
Appointments
-
Timetable
- Editing
-
Grouping
- Virtual Scrolling
- Drag & Drop
-
Customization
- Adaptability
-
Gantt
- Overview
- Data Binding
-
Filtering
- Sorting
- Strip Lines
- Export to PDF
- Validation
-
Customization
-
-
Messaging
-
WYSIWYG Editor
-
Forms
-
Data Editors
- Overview
-
Common Concepts
-
Calendar
- Check Box
- Color Box
-
Date Box
-
Date Range Box
-
Number Box
- Radio Group
-
Range Selector
- Range Slider
- Slider
- Switch
- Text Area
- Text Box
-
Drop-Downs
- Autocomplete
-
Drop Down Box
-
Select Box
-
Tag Box
-
Lookup
-
Buttons
-
File Upload / File Management
-
File Manager
- Overview
-
File System Types
-
Customization
-
File Uploader
-
-
Popup and Notifications
-
Navigation
- Overview
- Accordion
-
Action Sheet
-
Context Menu
-
Menu
- Multi View
-
Drawer
-
Tab Panel
-
Tabs
-
Toolbar
-
Stepper
- Pagination
-
List
-
Tree View
- Right-to-Left Support
-
Layout
-
Interactive Wrappers
-
Sortable
- Resizable
-
-
Progress Indicators
-
Maps
- Overview
-
Map
-
Vector Map
-
Data Binding
- Multiple Layers
-
Markers
- Legend
-
Zooming and Panning
-
Customization
-
-
Localization
Related Demos:
Your search did not match any results.
JavaScript/jQuery Data Grid - Right-To-Left Support
DevExtreme supports right-to-left layouts. To change a layout to RTL, set the JavaScript DataGrid's rtlEnabled property to true. You can also set rtlEnabled to true in the project's globalConfig to apply RTL to all DevExtreme components in your application.
In this demo, you can use the drop-down menu to switch between the different layouts. Note that this demo updates the dataField and caption properties to display translated content when you change the rtlEnabled value.
Backend API
$(() => {
const arabicColumns = [{
dataField: 'nameAr',
caption: 'الدولة',
}, {
dataField: 'capitalAr',
caption: 'عاصمة',
}, {
dataField: 'population',
format: {
type: 'fixedPoint',
precision: 0,
},
caption: 'عدد السكان (نسمة) 2013',
}, {
dataField: 'area',
format: {
type: 'fixedPoint',
precision: 0,
},
headerCellTemplate(container) {
container.append($('<div>المساحة (كم<sup>2</sup>)</div>'));
},
}, {
dataField: 'accession',
visible: false,
}];
const englishColumns = [{
dataField: 'nameEn',
caption: 'Name',
}, {
dataField: 'capitalEn',
caption: 'Capital',
}, {
dataField: 'population',
format: {
type: 'fixedPoint',
precision: 0,
},
}, {
dataField: 'area',
format: {
type: 'fixedPoint',
precision: 0,
},
headerCellTemplate(container) {
container.append($('<div>Area (km<sup>2</sup>)</div>'));
},
}, {
dataField: 'accession',
visible: false,
}];
const dataGrid = $('#gridContainer').dxDataGrid({
dataSource: europeanUnion,
keyExpr: 'nameEn',
showBorders: true,
searchPanel: {
visible: true,
},
paging: {
pageSize: 15,
},
pager: {
visible: true,
},
columns: englishColumns,
}).dxDataGrid('instance');
const languages = ['Arabic (Right-to-Left direction)', 'English (Left-to-Right direction)'];
$('#select-language').dxSelectBox({
items: languages,
value: languages[1],
inputAttr: { 'aria-label': 'Language' },
width: 250,
onValueChanged(data) {
const isRTL = data.value === languages[0];
dataGrid.option('rtlEnabled', isRTL);
dataGrid.option('columns', (isRTL) ? arabicColumns : englishColumns);
dataGrid.option('searchPanel.placeholder', (isRTL) ? 'بحث' : 'Search...');
},
});
});
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
<script>window.jQuery || document.write(decodeURIComponent('%3Cscript src="js/jquery.min.js"%3E%3C/script%3E'))</script>
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.2.4/css/dx.light.css" />
<script src="js/dx.all.js?v=25.2.4"></script>
<script src="data.js"></script>
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="index.js"></script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="gridContainer"></div>
<div class="options">
<div class="caption">Options</div>
<div class="option">
<span>Language:</span>
<div id="select-language"></div>
</div>
</div>
</div>
</body>
</html>
#gridContainer {
height: 440px;
}
#gridContainer sup {
font-size: 0.8em;
vertical-align: super;
line-height: 0;
}
.options {
padding: 20px;
margin-top: 20px;
background-color: rgba(191, 191, 191, 0.15);
}
.caption {
font-size: 18px;
font-weight: 500;
}
.option {
margin-top: 10px;
}
.option > span {
margin-right: 10px;
}
.option > .dx-widget {
display: inline-block;
vertical-align: middle;
}
const europeanUnion = [{
nameAr: 'النمسا',
nameEn: 'Austria',
population: 8451900,
area: 83855,
capitalAr: 'فيينا',
capitalEn: 'Vienna',
accession: 1995,
}, {
nameAr: 'بلجيكا',
nameEn: 'Belgium',
population: 11161600,
area: 30528,
capitalAr: 'بروكسل',
capitalEn: 'Brussels',
accession: 1957,
}, {
nameAr: 'بلغاريا',
nameEn: 'Bulgaria',
population: 7284600,
area: 110994,
capitalAr: 'صوفيا',
capitalEn: 'Sofia',
accession: 2007,
}, {
nameAr: 'كرواتيا',
nameEn: 'Croatia',
population: 4262100,
area: 56594,
capitalAr: 'زغرب',
capitalEn: 'Zagreb',
accession: 2013,
}, {
nameAr: 'قبرص',
nameEn: 'Cyprus',
population: 865900,
area: 9251,
capitalAr: 'نيقوسيا',
capitalEn: 'Nicosia',
accession: 2004,
}, {
nameAr: 'الجمهورية التشيكية',
nameEn: 'Czech Republic',
population: 10516100,
area: 78866,
capitalAr: 'براغ',
capitalEn: 'Prague',
accession: 2004,
}, {
nameAr: 'الدنمارك',
nameEn: 'Denmark',
population: 5602600,
area: 43075,
capitalAr: 'كوبنهاغن',
capitalEn: 'Copenhagen',
accession: 1973,
}, {
nameAr: 'استونيا',
nameEn: 'Estonia',
population: 1324800,
area: 45227,
capitalAr: 'تالين',
capitalEn: 'Tallinn',
accession: 2004,
}, {
nameAr: 'فنلندا',
nameEn: 'Finland',
population: 5426700,
area: 338424,
capitalAr: 'هلسنكي',
capitalEn: 'Helsinki',
accession: 1995,
}, {
nameAr: 'فرنسا',
nameEn: 'France',
population: 65633200,
area: 674843,
capitalAr: 'باريس',
capitalEn: 'Paris',
accession: 1957,
}, {
nameAr: 'ألمانيا',
nameEn: 'Germany',
population: 80523700,
area: 357021,
capitalAr: 'البرلينية',
capitalEn: 'Berlin',
accession: 1957,
}, {
nameAr: 'يونان',
nameEn: 'Greece',
population: 11062500,
area: 131990,
capitalAr: 'أثينا',
capitalEn: 'Athens',
accession: 1981,
}, {
nameAr: 'هنغاريا',
nameEn: 'Hungary',
population: 9908800,
area: 93030,
capitalAr: 'بودابست',
capitalEn: 'Budapest',
accession: 2004,
}, {
nameAr: 'أيرلندا',
nameEn: 'Ireland',
population: 4591100,
area: 70273,
capitalAr: 'دبلن',
capitalEn: 'Dublin',
accession: 1973,
}, {
nameAr: 'إيطاليا',
nameEn: 'Italy',
population: 59685200,
area: 301338,
capitalAr: 'روما',
capitalEn: 'Rome',
accession: 1957,
}, {
nameAr: 'لاتفيا',
nameEn: 'Latvia',
population: 2023800,
area: 64589,
capitalAr: 'ريغا',
capitalEn: 'Riga',
accession: 2004,
}, {
nameAr: 'ليتوانيا',
nameEn: 'Lithuania',
population: 2971900,
area: 65200,
capitalAr: 'فيلنيوس',
capitalEn: 'Vilnius',
accession: 2004,
}, {
nameAr: 'لوكسمبورغ',
nameEn: 'Luxembourg',
population: 537000,
area: 2586.4,
capitalAr: 'لوكسمبورغ',
capitalEn: 'Luxembourg',
accession: 1957,
}, {
nameAr: 'مالطا',
nameEn: 'Malta',
population: 421400,
area: 316,
capitalAr: 'فاليتا',
capitalEn: 'Valletta',
accession: 2004,
}, {
nameAr: 'هولندا',
nameEn: 'Netherlands',
population: 16779600,
area: 41543,
capitalAr: 'أمستردام',
capitalEn: 'Amsterdam',
accession: 1957,
}, {
nameAr: 'بولندا',
nameEn: 'Poland',
population: 38533300,
area: 312685,
capitalAr: 'وارسو',
capitalEn: 'Warsaw',
accession: 2004,
}, {
nameAr: 'البرتغال',
nameEn: 'Portugal',
population: 10487300,
area: 92390,
capitalAr: 'لشبونة',
capitalEn: 'Lisbon',
accession: 1986,
}, {
nameAr: 'رومانيا',
nameEn: 'Romania',
population: 20057500,
area: 238391,
capitalAr: 'بوخارست',
capitalEn: 'Bucharest',
accession: 2007,
}, {
nameAr: 'سلوفاكيا',
nameEn: 'Slovakia',
population: 5410800,
area: 49035,
capitalAr: 'براتيسلافا',
capitalEn: 'Bratislava',
accession: 2004,
}, {
nameAr: 'سلوفينيا',
nameEn: 'Slovenia',
population: 2058800,
area: 20273,
capitalAr: 'ليوبليانا',
capitalEn: 'Ljubljana',
accession: 2004,
}, {
nameAr: 'إسبانيا',
nameEn: 'Spain',
population: 46704300,
area: 504030,
capitalAr: 'مدريد',
capitalEn: 'Madrid',
accession: 1986,
}, {
nameAr: 'السويد',
nameEn: 'Sweden',
population: 9555900,
area: 449964,
capitalAr: 'ستوكهولم',
capitalEn: 'Stockholm',
accession: 1995,
}, {
nameAr: 'المملكة المتحدة',
nameEn: 'United Kingdom',
population: 63730100,
area: 243610,
capitalAr: 'لندن',
capitalEn: 'London',
accession: 1973,
}];

Backend API
<template>
<div>
<DxDataGrid
id="gridContainer"
:data-source="europeanUnion"
key-expr="nameEn"
:rtl-enabled="rtlEnabled"
:show-borders="true"
>
<DxPaging :page-size="15"/>
<DxPager :visible="true"/>
<DxSearchPanel
:visible="true"
:placeholder="placeholder"
/>
<DxColumn
:data-field="rtlEnabled ? 'nameAr' : 'nameEn'"
:caption="rtlEnabled ? 'الدولة' : 'Name'"
/>
<DxColumn
:data-field="rtlEnabled ? 'capitalAr' : 'capitalEn'"
:caption="rtlEnabled ? 'عاصمة' : 'Capital'"
/>
<DxColumn
:caption="rtlEnabled ? 'عدد السكان (نسمة) 2013' : 'Population'"
:format="{ type: 'fixedPoint', precision: 0 }"
data-field="population"
/>
<DxColumn
:header-cell-template="rtlEnabled ? 'arabicTemplate' : 'englishTemplate'"
:format="{ type: 'fixedPoint', precision: 0 }"
data-field="area"
/>
<DxColumn
:visible="false"
data-field="accession"
/>
<template #englishTemplate="{ data }">
<div>Area (km<sup>2</sup>)</div>
</template>
<template #arabicTemplate="{ data }">
<div>المساحة (كم<sup>2</sup>)</div>
</template>
</DxDataGrid>
<div class="options">
<div class="caption">Options</div>
<div class="option">
<span>Language: </span>
<DxSelectBox
id="select-language"
:items="languages"
:input-attr="{ 'aria-label': 'Language' }"
:value="languages[1]"
:width="250"
@valueChanged="onSelectLanguage($event)"
/>
</div>
</div>
</div>
</template>
<script setup lang="ts">
import { ref } from 'vue';
import {
DxDataGrid,
DxColumn,
DxPaging,
DxSearchPanel,
DxPager,
} from 'devextreme-vue/data-grid';
import DxSelectBox, { type DxSelectBoxTypes } from 'devextreme-vue/select-box';
import { europeanUnion } from './data.ts';
const languages = ['Arabic (Right-to-Left direction)', 'English (Left-to-Right direction)'];
const placeholder = ref('Search...');
const rtlEnabled = ref(false);
const onSelectLanguage = (e: DxSelectBoxTypes.ValueChangedEvent) => {
rtlEnabled.value = e.value === languages[0];
placeholder.value = rtlEnabled.value ? 'بحث' : 'Search...';
};
</script>
<style scoped>
#gridContainer {
height: 440px;
}
#gridContainer sup {
font-size: 0.8em;
vertical-align: super;
line-height: 0;
}
.options {
padding: 20px;
margin-top: 20px;
background-color: rgba(191, 191, 191, 0.15);
}
.caption {
font-size: 18px;
font-weight: 500;
}
.option {
margin-top: 10px;
}
.option > span {
margin-right: 10px;
}
.option > .dx-widget {
display: inline-block;
vertical-align: middle;
}
</style>
window.exports = window.exports || {};
window.config = {
transpiler: 'plugin-babel',
meta: {
'*.vue': {
loader: 'vue-loader',
},
'*.ts': {
loader: 'demo-ts-loader',
},
'*.svg': {
loader: 'svg-loader',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
},
paths: {
'project:': '../../../../',
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
},
map: {
'vue': 'npm:vue@3.4.27/dist/vue.esm-browser.js',
'@vue/shared': 'npm:@vue/shared@3.4.27/dist/shared.cjs.prod.js',
'vue-loader': 'npm:dx-systemjs-vue-browser@1.1.2/index.js',
'demo-ts-loader': 'project:utils/demo-ts-loader.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'svg-loader': 'project:utils/svg-loader.js',
'mitt': 'npm:mitt/dist/mitt.umd.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-vue': 'npm:devextreme-vue@link:../../packages/devextreme-vue/npm/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.7/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.24/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.64/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.8.0/dist/signals-core.min.js',
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme-vue': {
main: 'index.js',
},
'devextreme-vue/common': {
main: 'index.js',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
babelOptions: {
sourceMaps: false,
stage0: true,
},
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
export type EuropeanUnion = {
nameAr: string;
nameEn: string;
population: number;
area: number;
capitalAr: string;
capitalEn: string;
accession: number;
};
export const europeanUnion: EuropeanUnion[] = [{
nameAr: 'النمسا',
nameEn: 'Austria',
population: 8451900,
area: 83855,
capitalAr: 'فيينا',
capitalEn: 'Vienna',
accession: 1995,
}, {
nameAr: 'بلجيكا',
nameEn: 'Belgium',
population: 11161600,
area: 30528,
capitalAr: 'بروكسل',
capitalEn: 'Brussels',
accession: 1957,
}, {
nameAr: 'بلغاريا',
nameEn: 'Bulgaria',
population: 7284600,
area: 110994,
capitalAr: 'صوفيا',
capitalEn: 'Sofia',
accession: 2007,
}, {
nameAr: 'كرواتيا',
nameEn: 'Croatia',
population: 4262100,
area: 56594,
capitalAr: 'زغرب',
capitalEn: 'Zagreb',
accession: 2013,
}, {
nameAr: 'قبرص',
nameEn: 'Cyprus',
population: 865900,
area: 9251,
capitalAr: 'نيقوسيا',
capitalEn: 'Nicosia',
accession: 2004,
}, {
nameAr: 'الجمهورية التشيكية',
nameEn: 'Czech Republic',
population: 10516100,
area: 78866,
capitalAr: 'براغ',
capitalEn: 'Prague',
accession: 2004,
}, {
nameAr: 'الدنمارك',
nameEn: 'Denmark',
population: 5602600,
area: 43075,
capitalAr: 'كوبنهاغن',
capitalEn: 'Copenhagen',
accession: 1973,
}, {
nameAr: 'استونيا',
nameEn: 'Estonia',
population: 1324800,
area: 45227,
capitalAr: 'تالين',
capitalEn: 'Tallinn',
accession: 2004,
}, {
nameAr: 'فنلندا',
nameEn: 'Finland',
population: 5426700,
area: 338424,
capitalAr: 'هلسنكي',
capitalEn: 'Helsinki',
accession: 1995,
}, {
nameAr: 'فرنسا',
nameEn: 'France',
population: 65633200,
area: 674843,
capitalAr: 'باريس',
capitalEn: 'Paris',
accession: 1957,
}, {
nameAr: 'ألمانيا',
nameEn: 'Germany',
population: 80523700,
area: 357021,
capitalAr: 'البرلينية',
capitalEn: 'Berlin',
accession: 1957,
}, {
nameAr: 'يونان',
nameEn: 'Greece',
population: 11062500,
area: 131990,
capitalAr: 'أثينا',
capitalEn: 'Athens',
accession: 1981,
}, {
nameAr: 'هنغاريا',
nameEn: 'Hungary',
population: 9908800,
area: 93030,
capitalAr: 'بودابست',
capitalEn: 'Budapest',
accession: 2004,
}, {
nameAr: 'أيرلندا',
nameEn: 'Ireland',
population: 4591100,
area: 70273,
capitalAr: 'دبلن',
capitalEn: 'Dublin',
accession: 1973,
}, {
nameAr: 'إيطاليا',
nameEn: 'Italy',
population: 59685200,
area: 301338,
capitalAr: 'روما',
capitalEn: 'Rome',
accession: 1957,
}, {
nameAr: 'لاتفيا',
nameEn: 'Latvia',
population: 2023800,
area: 64589,
capitalAr: 'ريغا',
capitalEn: 'Riga',
accession: 2004,
}, {
nameAr: 'ليتوانيا',
nameEn: 'Lithuania',
population: 2971900,
area: 65200,
capitalAr: 'فيلنيوس',
capitalEn: 'Vilnius',
accession: 2004,
}, {
nameAr: 'لوكسمبورغ',
nameEn: 'Luxembourg',
population: 537000,
area: 2586.4,
capitalAr: 'لوكسمبورغ',
capitalEn: 'Luxembourg',
accession: 1957,
}, {
nameAr: 'مالطا',
nameEn: 'Malta',
population: 421400,
area: 316,
capitalAr: 'فاليتا',
capitalEn: 'Valletta',
accession: 2004,
}, {
nameAr: 'هولندا',
nameEn: 'Netherlands',
population: 16779600,
area: 41543,
capitalAr: 'أمستردام',
capitalEn: 'Amsterdam',
accession: 1957,
}, {
nameAr: 'بولندا',
nameEn: 'Poland',
population: 38533300,
area: 312685,
capitalAr: 'وارسو',
capitalEn: 'Warsaw',
accession: 2004,
}, {
nameAr: 'البرتغال',
nameEn: 'Portugal',
population: 10487300,
area: 92390,
capitalAr: 'لشبونة',
capitalEn: 'Lisbon',
accession: 1986,
}, {
nameAr: 'رومانيا',
nameEn: 'Romania',
population: 20057500,
area: 238391,
capitalAr: 'بوخارست',
capitalEn: 'Bucharest',
accession: 2007,
}, {
nameAr: 'سلوفاكيا',
nameEn: 'Slovakia',
population: 5410800,
area: 49035,
capitalAr: 'براتيسلافا',
capitalEn: 'Bratislava',
accession: 2004,
}, {
nameAr: 'سلوفينيا',
nameEn: 'Slovenia',
population: 2058800,
area: 20273,
capitalAr: 'ليوبليانا',
capitalEn: 'Ljubljana',
accession: 2004,
}, {
nameAr: 'إسبانيا',
nameEn: 'Spain',
population: 46704300,
area: 504030,
capitalAr: 'مدريد',
capitalEn: 'Madrid',
accession: 1986,
}, {
nameAr: 'السويد',
nameEn: 'Sweden',
population: 9555900,
area: 449964,
capitalAr: 'ستوكهولم',
capitalEn: 'Stockholm',
accession: 1995,
}, {
nameAr: 'المملكة المتحدة',
nameEn: 'United Kingdom',
population: 63730100,
area: 243610,
capitalAr: 'لندن',
capitalEn: 'London',
accession: 1973,
}];
import { createApp } from 'vue';
import App from './App.vue';
createApp(App).mount('#app');
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.2.3/css/dx.light.css" />
<script type="module">
import * as vueCompilerSFC from "https://cdn.jsdelivr.net/npm/@vue/compiler-sfc@3.4.27/dist/compiler-sfc.esm-browser.js";
window.vueCompilerSFC = vueCompilerSFC;
</script>
<script src="https://cdn.jsdelivr.net/npm/typescript@5.9.3/lib/typescript.js"></script>
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.ts");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"> </div>
</div>
</body>
</html>

import React from 'react';
import DataGrid, { Column, Paging, SearchPanel } from 'devextreme-react/data-grid';
import SelectBox from 'devextreme-react/select-box';
import service from './data.js';
const populationFormat = { type: 'fixedPoint', precision: 0 };
const areaFormat = { type: 'fixedPoint', precision: 0 };
class App extends React.Component {
constructor(props) {
super(props);
this.dataSource = service.getEuropeanUnion();
this.languages = ['Arabic (Right-to-Left direction)', 'English (Left-to-Right direction)'];
this.state = {
placeholder: 'Search...',
rtlEnabled: false,
selectedValue: this.languages[1],
};
this.selectLanguage = this.selectLanguage.bind(this);
this.headerCellRender = this.headerCellRender.bind(this);
}
selectLanguage(e) {
const newRtlEnabled = e.value === this.languages[0];
this.setState({
rtlEnabled: newRtlEnabled,
placeholder: newRtlEnabled ? 'بحث' : 'Search...',
selectedValue: e.value,
});
}
headerCellRender() {
return (
<div>
{this.state.rtlEnabled ? (
<div>المساحة (كم<sup>2</sup>)</div>
) : (
<div>Area (km<sup>2</sup>)</div>
)}
</div>
);
}
render() {
const { rtlEnabled, placeholder, selectedValue } = this.state;
return (
<React.Fragment>
<DataGrid id="gridContainer"
dataSource={this.dataSource}
keyExpr="nameEn"
rtlEnabled={rtlEnabled}
showBorders={true}>
<Paging defaultPageSize={15} />
<SearchPanel visible={true} placeholder={placeholder} />
<Column dataField={rtlEnabled ? 'nameAr' : 'nameEn'}
caption={rtlEnabled ? 'الدولة' : 'Name'} />
<Column dataField={rtlEnabled ? 'capitalAr' : 'capitalEn'}
caption={rtlEnabled ? 'عاصمة' : 'Capital'} />
<Column dataField="population"
caption={rtlEnabled ? 'عدد السكان (نسمة) 2013' : 'Population'}
format={populationFormat} />
<Column dataField="area"
headerCellRender={this.headerCellRender}
format={areaFormat} />
<Column dataField="accession" visible={false} />
</DataGrid>
<div className="options">
<div className="caption">Options</div>
<div className="option">
<span>Language: </span>
<SelectBox id="select-language"
items={this.languages}
value={selectedValue}
width={250}
onValueChanged={this.selectLanguage} />
</div>
</div>
</React.Fragment>
);
}
}
export default App;
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.js';
ReactDOM.render(
<App />,
document.getElementById('app'),
);
<!DOCTYPE html>
<html>
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/21.2.7/css/dx.common.css" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/21.2.7/css/dx.light.css" />
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="https://unpkg.com/core-js@2.4.1/client/shim.min.js"></script>
<script src="https://unpkg.com/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.js");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"></div>
</div>
</body>
</html>
#gridContainer {
height: 440px;
}
#gridContainer sup {
font-size: 0.8em;
vertical-align: super;
line-height: 0;
}
.options {
padding: 20px;
margin-top: 20px;
background-color: rgba(191, 191, 191, 0.15);
}
.caption {
font-size: 18px;
font-weight: 500;
}
.option {
margin-top: 10px;
}
.option > span {
margin-right: 10px;
}
.option > .dx-widget {
display: inline-block;
vertical-align: middle;
}
const europeanUnion = [{
nameAr: 'النمسا',
nameEn: 'Austria',
population: 8451900,
area: 83855,
capitalAr: 'فيينا',
capitalEn: 'Vienna',
accession: 1995,
}, {
nameAr: 'بلجيكا',
nameEn: 'Belgium',
population: 11161600,
area: 30528,
capitalAr: 'بروكسل',
capitalEn: 'Brussels',
accession: 1957,
}, {
nameAr: 'بلغاريا',
nameEn: 'Bulgaria',
population: 7284600,
area: 110994,
capitalAr: 'صوفيا',
capitalEn: 'Sofia',
accession: 2007,
}, {
nameAr: 'كرواتيا',
nameEn: 'Croatia',
population: 4262100,
area: 56594,
capitalAr: 'زغرب',
capitalEn: 'Zagreb',
accession: 2013,
}, {
nameAr: 'قبرص',
nameEn: 'Cyprus',
population: 865900,
area: 9251,
capitalAr: 'نيقوسيا',
capitalEn: 'Nicosia',
accession: 2004,
}, {
nameAr: 'الجمهورية التشيكية',
nameEn: 'Czech Republic',
population: 10516100,
area: 78866,
capitalAr: 'براغ',
capitalEn: 'Prague',
accession: 2004,
}, {
nameAr: 'الدنمارك',
nameEn: 'Denmark',
population: 5602600,
area: 43075,
capitalAr: 'كوبنهاغن',
capitalEn: 'Copenhagen',
accession: 1973,
}, {
nameAr: 'استونيا',
nameEn: 'Estonia',
population: 1324800,
area: 45227,
capitalAr: 'تالين',
capitalEn: 'Tallinn',
accession: 2004,
}, {
nameAr: 'فنلندا',
nameEn: 'Finland',
population: 5426700,
area: 338424,
capitalAr: 'هلسنكي',
capitalEn: 'Helsinki',
accession: 1995,
}, {
nameAr: 'فرنسا',
nameEn: 'France',
population: 65633200,
area: 674843,
capitalAr: 'باريس',
capitalEn: 'Paris',
accession: 1957,
}, {
nameAr: 'ألمانيا',
nameEn: 'Germany',
population: 80523700,
area: 357021,
capitalAr: 'البرلينية',
capitalEn: 'Berlin',
accession: 1957,
}, {
nameAr: 'يونان',
nameEn: 'Greece',
population: 11062500,
area: 131990,
capitalAr: 'أثينا',
capitalEn: 'Athens',
accession: 1981,
}, {
nameAr: 'هنغاريا',
nameEn: 'Hungary',
population: 9908800,
area: 93030,
capitalAr: 'بودابست',
capitalEn: 'Budapest',
accession: 2004,
}, {
nameAr: 'أيرلندا',
nameEn: 'Ireland',
population: 4591100,
area: 70273,
capitalAr: 'دبلن',
capitalEn: 'Dublin',
accession: 1973,
}, {
nameAr: 'إيطاليا',
nameEn: 'Italy',
population: 59685200,
area: 301338,
capitalAr: 'روما',
capitalEn: 'Rome',
accession: 1957,
}, {
nameAr: 'لاتفيا',
nameEn: 'Latvia',
population: 2023800,
area: 64589,
capitalAr: 'ريغا',
capitalEn: 'Riga',
accession: 2004,
}, {
nameAr: 'ليتوانيا',
nameEn: 'Lithuania',
population: 2971900,
area: 65200,
capitalAr: 'فيلنيوس',
capitalEn: 'Vilnius',
accession: 2004,
}, {
nameAr: 'لوكسمبورغ',
nameEn: 'Luxembourg',
population: 537000,
area: 2586.4,
capitalAr: 'لوكسمبورغ',
capitalEn: 'Luxembourg',
accession: 1957,
}, {
nameAr: 'مالطا',
nameEn: 'Malta',
population: 421400,
area: 316,
capitalAr: 'فاليتا',
capitalEn: 'Valletta',
accession: 2004,
}, {
nameAr: 'هولندا',
nameEn: 'Netherlands',
population: 16779600,
area: 41543,
capitalAr: 'أمستردام',
capitalEn: 'Amsterdam',
accession: 1957,
}, {
nameAr: 'بولندا',
nameEn: 'Poland',
population: 38533300,
area: 312685,
capitalAr: 'وارسو',
capitalEn: 'Warsaw',
accession: 2004,
}, {
nameAr: 'البرتغال',
nameEn: 'Portugal',
population: 10487300,
area: 92390,
capitalAr: 'لشبونة',
capitalEn: 'Lisbon',
accession: 1986,
}, {
nameAr: 'رومانيا',
nameEn: 'Romania',
population: 20057500,
area: 238391,
capitalAr: 'بوخارست',
capitalEn: 'Bucharest',
accession: 2007,
}, {
nameAr: 'سلوفاكيا',
nameEn: 'Slovakia',
population: 5410800,
area: 49035,
capitalAr: 'براتيسلافا',
capitalEn: 'Bratislava',
accession: 2004,
}, {
nameAr: 'سلوفينيا',
nameEn: 'Slovenia',
population: 2058800,
area: 20273,
capitalAr: 'ليوبليانا',
capitalEn: 'Ljubljana',
accession: 2004,
}, {
nameAr: 'إسبانيا',
nameEn: 'Spain',
population: 46704300,
area: 504030,
capitalAr: 'مدريد',
capitalEn: 'Madrid',
accession: 1986,
}, {
nameAr: 'السويد',
nameEn: 'Sweden',
population: 9555900,
area: 449964,
capitalAr: 'ستوكهولم',
capitalEn: 'Stockholm',
accession: 1995,
}, {
nameAr: 'المملكة المتحدة',
nameEn: 'United Kingdom',
population: 63730100,
area: 243610,
capitalAr: 'لندن',
capitalEn: 'London',
accession: 1973,
}];
export default {
getEuropeanUnion() {
return europeanUnion;
},
};
window.config = {
transpiler: 'plugin-babel',
meta: {
'devextreme/localization.js': {
'esModule': true,
},
},
paths: {
'npm:': 'https://unpkg.com/',
},
defaultExtension: 'js',
map: {
'react': 'npm:react@17.0.2/umd/react.development.js',
'react-dom': 'npm:react-dom@17.0.2/umd/react-dom.development.js',
'prop-types': 'npm:prop-types@15.8.1/prop-types.js',
'rrule': 'npm:rrule@2.6.6/dist/es5/rrule.js',
'luxon': 'npm:luxon@1.28.0/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign@1.1.0',
'devextreme': 'npm:devextreme@21.2.7/cjs',
'devextreme-react': 'npm:devextreme-react@21.2.7',
'jszip': 'npm:jszip@3.7.1/dist/jszip.min.js',
'devextreme-quill': 'npm:devextreme-quill@1.5.14/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.1.47/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.0.13/dist/dx-gantt.js',
'@devextreme/runtime': 'npm:@devextreme/runtime@2.3.14',
'inferno': 'npm:inferno@7.4.11/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat@7.4.11/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@7.4.11/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate@7.4.11/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode@7.4.11/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class@7.4.11/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras@7.4.11/dist/inferno-extras.min.js',
// SystemJS plugins
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
},
packages: {
'devextreme': {
defaultExtension: 'js',
},
'devextreme-react': {
main: 'index.js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:@devextreme/runtime@2.3.14/inferno/package.json',
],
babelOptions: {
sourceMaps: false,
stage0: true,
react: true,
},
};
System.config(window.config);

Backend API
<dx-data-grid
id="gridContainer"
[dataSource]="dataSource"
keyExpr="nameEn"
[rtlEnabled]="rtlEnabled"
[showBorders]="true"
>
<dxo-data-grid-paging [pageSize]="15"></dxo-data-grid-paging>
<dxo-data-grid-pager [visible]="true"></dxo-data-grid-pager>
<dxo-data-grid-search-panel
[visible]="true"
[placeholder]="placeholder"
></dxo-data-grid-search-panel>
<dxi-data-grid-column
[dataField]="rtlEnabled ? 'nameAr' : 'nameEn'"
[caption]="rtlEnabled ? 'الدولة' : 'Name'"
>
</dxi-data-grid-column>
<dxi-data-grid-column
[dataField]="rtlEnabled ? 'capitalAr' : 'capitalEn'"
[caption]="rtlEnabled ? 'عاصمة' : 'Capital'"
>
</dxi-data-grid-column>
<dxi-data-grid-column
dataField="population"
[caption]="rtlEnabled ? 'عدد السكان (نسمة) 2013' : 'Population'"
[format]="{ type: 'fixedPoint', precision: 0 }"
>
</dxi-data-grid-column>
<dxi-data-grid-column
dataField="area"
[headerCellTemplate]="rtlEnabled ? 'arabicTemplate' : 'englishTemplate'"
[format]="{ type: 'fixedPoint', precision: 0 }"
>
</dxi-data-grid-column>
<dxi-data-grid-column
dataField="accession"
[visible]="false"
></dxi-data-grid-column>
<div *dxTemplate="let item of 'englishTemplate'">
<div>Area (km<sup>2</sup>)</div>
</div>
<div *dxTemplate="let item of 'arabicTemplate'">
<div>المساحة (كم<sup>2</sup>)</div>
</div>
</dx-data-grid>
<div class="options">
<div class="caption">Options</div>
<div class="option">
<span>Language:</span>
<dx-select-box
id="select-language"
[items]="languages"
[inputAttr]="{ 'aria-label': 'Language' }"
[value]="languages[1]"
[width]="250"
(onValueChanged)="onSelectLanguage($event)"
>
</dx-select-box>
</div>
</div>
import { bootstrapApplication } from '@angular/platform-browser';
import { Component, enableProdMode, provideZoneChangeDetection } from '@angular/core';
import { DxDataGridModule, DxSelectBoxModule } from 'devextreme-angular';
import { Service, EuropeanUnion } from './app.service';
if (!/localhost/.test(document.location.host)) {
enableProdMode();
}
let modulePrefix = '';
// @ts-ignore
if (window && window.config?.packageConfigPaths) {
modulePrefix = '/app';
}
@Component({
selector: 'demo-app',
templateUrl: `app/app.component.html`,
styleUrls: [`app/app.component.css`],
providers: [Service],
preserveWhitespaces: true,
imports: [
DxDataGridModule,
DxSelectBoxModule,
],
})
export class AppComponent {
dataSource: EuropeanUnion[];
placeholder = 'Search...';
rtlEnabled = false;
languages: string[] = ['Arabic (Right-to-Left direction)', 'English (Left-to-Right direction)'];
constructor(service: Service) {
this.dataSource = service.getEuropeanUnion();
}
onSelectLanguage(data) {
this.rtlEnabled = data.value === this.languages[0];
this.placeholder = this.rtlEnabled ? 'بحث' : 'Search...';
}
}
bootstrapApplication(AppComponent, {
providers: [
provideZoneChangeDetection({ eventCoalescing: true, runCoalescing: true }),
],
});
::ng-deep #gridContainer {
height: 440px;
}
::ng-deep #gridContainer sup {
font-size: 0.8em;
vertical-align: super;
line-height: 0;
}
.options {
padding: 20px;
margin-top: 20px;
background-color: rgba(191, 191, 191, 0.15);
}
.caption {
font-size: 18px;
font-weight: 500;
}
.option {
margin-top: 10px;
}
.option > span {
margin-right: 10px;
}
::ng-deep .option > .dx-widget {
display: inline-block;
vertical-align: middle;
}
import { Injectable } from '@angular/core';
export class EuropeanUnion {
nameAr: string;
nameEn: string;
population: number;
area: number;
capitalAr: string;
capitalEn: string;
accession: number;
}
const europeanUnion: EuropeanUnion[] = [{
nameAr: 'النمسا',
nameEn: 'Austria',
population: 8451900,
area: 83855,
capitalAr: 'فيينا',
capitalEn: 'Vienna',
accession: 1995,
}, {
nameAr: 'بلجيكا',
nameEn: 'Belgium',
population: 11161600,
area: 30528,
capitalAr: 'بروكسل',
capitalEn: 'Brussels',
accession: 1957,
}, {
nameAr: 'بلغاريا',
nameEn: 'Bulgaria',
population: 7284600,
area: 110994,
capitalAr: 'صوفيا',
capitalEn: 'Sofia',
accession: 2007,
}, {
nameAr: 'كرواتيا',
nameEn: 'Croatia',
population: 4262100,
area: 56594,
capitalAr: 'زغرب',
capitalEn: 'Zagreb',
accession: 2013,
}, {
nameAr: 'قبرص',
nameEn: 'Cyprus',
population: 865900,
area: 9251,
capitalAr: 'نيقوسيا',
capitalEn: 'Nicosia',
accession: 2004,
}, {
nameAr: 'الجمهورية التشيكية',
nameEn: 'Czech Republic',
population: 10516100,
area: 78866,
capitalAr: 'براغ',
capitalEn: 'Prague',
accession: 2004,
}, {
nameAr: 'الدنمارك',
nameEn: 'Denmark',
population: 5602600,
area: 43075,
capitalAr: 'كوبنهاغن',
capitalEn: 'Copenhagen',
accession: 1973,
}, {
nameAr: 'استونيا',
nameEn: 'Estonia',
population: 1324800,
area: 45227,
capitalAr: 'تالين',
capitalEn: 'Tallinn',
accession: 2004,
}, {
nameAr: 'فنلندا',
nameEn: 'Finland',
population: 5426700,
area: 338424,
capitalAr: 'هلسنكي',
capitalEn: 'Helsinki',
accession: 1995,
}, {
nameAr: 'فرنسا',
nameEn: 'France',
population: 65633200,
area: 674843,
capitalAr: 'باريس',
capitalEn: 'Paris',
accession: 1957,
}, {
nameAr: 'ألمانيا',
nameEn: 'Germany',
population: 80523700,
area: 357021,
capitalAr: 'البرلينية',
capitalEn: 'Berlin',
accession: 1957,
}, {
nameAr: 'يونان',
nameEn: 'Greece',
population: 11062500,
area: 131990,
capitalAr: 'أثينا',
capitalEn: 'Athens',
accession: 1981,
}, {
nameAr: 'هنغاريا',
nameEn: 'Hungary',
population: 9908800,
area: 93030,
capitalAr: 'بودابست',
capitalEn: 'Budapest',
accession: 2004,
}, {
nameAr: 'أيرلندا',
nameEn: 'Ireland',
population: 4591100,
area: 70273,
capitalAr: 'دبلن',
capitalEn: 'Dublin',
accession: 1973,
}, {
nameAr: 'إيطاليا',
nameEn: 'Italy',
population: 59685200,
area: 301338,
capitalAr: 'روما',
capitalEn: 'Rome',
accession: 1957,
}, {
nameAr: 'لاتفيا',
nameEn: 'Latvia',
population: 2023800,
area: 64589,
capitalAr: 'ريغا',
capitalEn: 'Riga',
accession: 2004,
}, {
nameAr: 'ليتوانيا',
nameEn: 'Lithuania',
population: 2971900,
area: 65200,
capitalAr: 'فيلنيوس',
capitalEn: 'Vilnius',
accession: 2004,
}, {
nameAr: 'لوكسمبورغ',
nameEn: 'Luxembourg',
population: 537000,
area: 2586.4,
capitalAr: 'لوكسمبورغ',
capitalEn: 'Luxembourg',
accession: 1957,
}, {
nameAr: 'مالطا',
nameEn: 'Malta',
population: 421400,
area: 316,
capitalAr: 'فاليتا',
capitalEn: 'Valletta',
accession: 2004,
}, {
nameAr: 'هولندا',
nameEn: 'Netherlands',
population: 16779600,
area: 41543,
capitalAr: 'أمستردام',
capitalEn: 'Amsterdam',
accession: 1957,
}, {
nameAr: 'بولندا',
nameEn: 'Poland',
population: 38533300,
area: 312685,
capitalAr: 'وارسو',
capitalEn: 'Warsaw',
accession: 2004,
}, {
nameAr: 'البرتغال',
nameEn: 'Portugal',
population: 10487300,
area: 92390,
capitalAr: 'لشبونة',
capitalEn: 'Lisbon',
accession: 1986,
}, {
nameAr: 'رومانيا',
nameEn: 'Romania',
population: 20057500,
area: 238391,
capitalAr: 'بوخارست',
capitalEn: 'Bucharest',
accession: 2007,
}, {
nameAr: 'سلوفاكيا',
nameEn: 'Slovakia',
population: 5410800,
area: 49035,
capitalAr: 'براتيسلافا',
capitalEn: 'Bratislava',
accession: 2004,
}, {
nameAr: 'سلوفينيا',
nameEn: 'Slovenia',
population: 2058800,
area: 20273,
capitalAr: 'ليوبليانا',
capitalEn: 'Ljubljana',
accession: 2004,
}, {
nameAr: 'إسبانيا',
nameEn: 'Spain',
population: 46704300,
area: 504030,
capitalAr: 'مدريد',
capitalEn: 'Madrid',
accession: 1986,
}, {
nameAr: 'السويد',
nameEn: 'Sweden',
population: 9555900,
area: 449964,
capitalAr: 'ستوكهولم',
capitalEn: 'Stockholm',
accession: 1995,
}, {
nameAr: 'المملكة المتحدة',
nameEn: 'United Kingdom',
population: 63730100,
area: 243610,
capitalAr: 'لندن',
capitalEn: 'London',
accession: 1973,
}];
@Injectable()
export class Service {
getEuropeanUnion() {
return europeanUnion;
}
}
// In real applications, you should not transpile code in the browser.
// You can see how to create your own application with Angular and DevExtreme here:
// https://js.devexpress.com/Documentation/Guide/Angular_Components/Getting_Started/Create_a_DevExtreme_Application/
const componentNames = [
'accordion',
'action-sheet',
'autocomplete',
'bar-gauge',
'box',
'bullet',
'button-group',
'button',
'calendar',
'card-view',
'chart',
'chat',
'check-box',
'circular-gauge',
'color-box',
'context-menu',
'data-grid',
'date-box',
'date-range-box',
'defer-rendering',
'diagram',
'draggable',
'drawer',
'drop-down-box',
'drop-down-button',
'file-manager',
'file-uploader',
'filter-builder',
'form',
'funnel',
'gallery',
'gantt',
'html-editor',
'linear-gauge',
'list',
'load-indicator',
'load-panel',
'lookup',
'map',
'menu',
'multi-view',
'nested',
'number-box',
'pagination',
'pie-chart',
'pivot-grid-field-chooser',
'pivot-grid',
'polar-chart',
'popover',
'popup',
'progress-bar',
'radio-group',
'range-selector',
'range-slider',
'recurrence-editor',
'resizable',
'responsive-box',
'sankey',
'scheduler',
'scroll-view',
'select-box',
'slider',
'sortable',
'sparkline',
'speech-to-text',
'speed-dial-action',
'splitter',
'stepper',
'switch',
'tab-panel',
'tabs',
'tag-box',
'text-area',
'text-box',
'tile-view',
'toast',
'toolbar',
'tooltip',
'tree-list',
'tree-map',
'tree-view',
'validation-group',
'validation-summary',
'validator',
'vector-map',
];
window.exports = window.exports || {};
window.config = {
transpiler: 'ts',
typescriptOptions: {
module: 'system',
emitDecoratorMetadata: true,
experimentalDecorators: true,
},
meta: {
'typescript': {
'exports': 'ts',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'@angular/platform-browser-dynamic': {
'esModule': true,
},
'@angular/platform-browser': {
'esModule': true,
},
'@angular/core': {
'esModule': true,
},
'@angular/common': {
'esModule': true,
},
'@angular/common/http': {
'esModule': true,
},
'@angular/animations': {
'esModule': true,
},
'@angular/forms': {
'esModule': true,
},
'openai': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
},
map: {
'ts': 'npm:plugin-typescript@8.0.0/lib/plugin.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
/* @angular */
'@angular/compiler': 'bundles:@angular/compiler.umd.js',
'@angular/platform-browser-dynamic': 'bundles:@angular/platform-browser-dynamic.umd.js',
'@angular/core': 'bundles:@angular/core.umd.js',
'@angular/core/primitives/signals': 'bundles:@angular/core.primitives.signals.umd.js',
'@angular/core/primitives/di': 'bundles:@angular/core.primitives.di.umd.js',
'@angular/common': 'bundles:@angular/common.umd.js',
'@angular/common/http': 'bundles:@angular/common-http.umd.js',
'@angular/platform-browser': 'bundles:@angular/platform-browser.umd.js',
'@angular/platform-browser/animations': 'bundles:@angular/platform-browser.umd.js',
'@angular/forms': 'bundles:@angular/forms.umd.js',
/* devextreme */
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.7/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.24',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.64',
/* devextreme-angular umd maps */
'devextreme-angular': 'bundles:devextreme-angular/devextreme-angular.umd.js',
'devextreme-angular/common/ai-integration': 'bundles:devextreme-angular/devextreme-angular-common-ai-integration.umd.js',
'devextreme-angular/core': 'bundles:devextreme-angular/devextreme-angular-core.umd.js',
'devextreme-angular/common/charts': 'bundles:devextreme-angular/devextreme-angular-common-charts.umd.js',
'devextreme-angular/common/core/animation': 'bundles:devextreme-angular/devextreme-angular-common-core-animation.umd.js',
'devextreme-angular/common/core/environment': 'bundles:devextreme-angular/devextreme-angular-common-core-environment.umd.js',
'devextreme-angular/common/core/events': 'bundles:devextreme-angular/devextreme-angular-common-core-events.umd.js',
'devextreme-angular/common/core/localization': 'bundles:devextreme-angular/devextreme-angular-common-core-localization.umd.js',
'devextreme-angular/common/core': 'bundles:devextreme-angular/devextreme-angular-common-core.umd.js',
'devextreme-angular/common/data/custom-store': 'bundles:devextreme-angular/devextreme-angular-common-data-custom-store.umd.js',
'devextreme-angular/common/data': 'bundles:devextreme-angular/devextreme-angular-common-data.umd.js',
'devextreme-angular/common/export/excel': 'bundles:devextreme-angular/devextreme-angular-common-export-excel.umd.js',
'devextreme-angular/common/export/pdf': 'bundles:devextreme-angular/devextreme-angular-common-export-pdf.umd.js',
'devextreme-angular/common/export': 'bundles:devextreme-angular/devextreme-angular-common-export.umd.js',
'devextreme-angular/common/grids': 'bundles:devextreme-angular/devextreme-angular-common-grids.umd.js',
'devextreme-angular/common': 'bundles:devextreme-angular/devextreme-angular-common.umd.js',
'devextreme-angular/http': 'bundles:devextreme-angular/devextreme-angular-http.umd.js',
'devextreme-angular/core/tokens': 'bundles:devextreme-angular/devextreme-angular-core-tokens.umd.js',
...componentNames.reduce((acc, name) => {
acc[`devextreme-angular/ui/${name}`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}.umd.js`;
acc[`devextreme-angular/ui/${name}/nested`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}-nested.umd.js`;
return acc;
}, {}),
'tslib': 'npm:tslib/tslib.js',
'rxjs': 'npm:rxjs@7.5.3/dist/bundles/rxjs.umd.js',
'rxjs/operators': 'npm:rxjs@7.5.3/dist/cjs/operators/index.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.8.0/dist/signals-core.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
'zone.js': 'npm:zone.js@0.15.1/bundles/zone.umd.js',
},
packages: {
'app': {
main: './app.component.ts',
defaultExtension: 'ts',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
'rxjs': {
defaultExtension: 'js',
},
'rxjs/operators': {
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:rxjs@7.5.3/package.json',
'npm:rxjs@7.5.3/operators/package.json',
'npm:devexpress-diagram@2.2.24/package.json',
'npm:devexpress-gantt@4.1.64/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line no-console
// System.import('@angular/compiler').catch(console.error.bind(console));
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"@angular/core": {
"version": "21.0.5"
},
"core-js": {
"version": "2.6.12"
},
"typescript": {
"version": "5.9.3"
},
"zone.js": {
"version": "0.15.1"
}
};
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.2.3/css/dx.light.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/zone.js@0.15.1/bundles/zone.umd.js"></script>
<script src="https://cdn.jsdelivr.net/npm/reflect-metadata@0.1.13/Reflect.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script src="config.js"></script>
<script>
System.import("app").catch(console.error.bind(console));
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<demo-app>Loading...</demo-app>
</div>
</body>
</html>